module d_reg(clk, q, d, clr);
   parameter width = 32, prop = 8;
   input clk;             // Set the data on the positive edge of this clock.
   input clr;             // The positive edge of this signal will clear the flip-flop.
   input [width-1:0] d;   // The input which is used to set Q.
   output [width-1:0] q;  // This is the "usual" Q output of a D-type flip-flop.

   reg [width-1:0]    q;
   
   always @(negedge clr)
     begin 
	#(prop) q <= 0;	// BWAT:
     end
   
   always @(negedge clk)
     begin	
	#(prop) q <= d; // BWAT:
     end   
endmodule // d_reg

