/*
 * sel0 | sel1 | out
 * ==================
 *  0   |  0   | in0
 *  0   |  1   | in1
 *  1   |  0   | in2
 *  1   |  1   | in3
 * 
 */
module mux4 (sel0, sel1, out, in0, in1, in2, in3);	
   parameter width = 32, prop = 0;	
   input sel1;             // Selector LSB
   input sel0;             // Selector MSB
   input [width-1:0] in0;  // Input data
   input [width-1:0] in1;  //   "     "
   input [width-1:0] in2;  //   "     "
   input [width-1:0] in3;  //   "     "
   output [width-1:0] out; // Selected data
   
   assign #(prop) out = sel1 ? (sel0 ? in3 
                                     : in2) 
                             : (sel0 ? in1 
                                     : in0);   
endmodule // mux4
