
module opdec(opcode, nop, add, sub, or2, and2, not2, xor2, cmp, br, jmp, ld, ldi, ldx, st, stx, hlt, alu, ldst);
// PORT DECLARATIONS
   input [4:0] opcode; // The instruction to decode.
   output      nop; // If nop == 1'b1 then the instruction is a NOP.
   output      add; // If add == 1'b1 then the instruction is an ADD.
   output      sub;  // If sub == 1'b1 then the instruction is a SUB.
   output      or2;  // If or2 == 1'b1 then the instruction is an OR.
   output      and2; // If and2 == 1'b1 then the instruction is an AND.
   output      not2; // If not2 == 1'b1 then the instruction is a NOT.
   output      xor2; // If xor2 == 1'b1 then the instruction is an XOR.
   output      cmp; // If cmp == 1'b1 then the instruction is a CMP.
   output      br; // If br == 1'b1 then the instruction is a Bxx.
   output      jmp; // If jmp == 1'b1 then the instruction is a JMP.
   output      ld; // If ld == 1'b1 then the instruction is a LD.
   output      ldi; // If ldi == 1'b1 then the instruction is a LDI.
   output      ldx; // If ldx == 1'b1 then the instruction is a LDX.
   output      st;  // If st == 1'b1 then the instruction is a ST.
   output      stx; // If stx == 1'b1 then the instruction is a STX.
   output      hlt; // If hlt == 1'b1 then the instruction is a HLT.
   output      alu; // If alu == 1'b1 then the instruction is an ALU operation.
   output      ldst; // If ldst == 1'b1 then the instruction is a memory operation.

   
   // Instantiate the opdec.v module
   // has a delay of 6 inside the module (not a parameter)
   dcd5_32 opcodedec(opcode, nop, add, sub, or2, and2, not2, xor2, cmp, br, jmp, ld, ldi, ldx, st, stx, hlt);
      
   // Logic to generate alu and ldst signal
   or #(3) g1(alu,add,sub,or2,and2,not2,xor2,cmp);
   or #(3) g2(ldst,ld,ldi,ldx,st,stx);      
endmodule // opdec
