module setcc(op1, op2, result, add, sub, cmp, c, z, n, v);	
   parameter width = 32;
   input [width-1:0] op1;     // An instruction operand.
   input [width-1:0] op2;     // An instruction operand.
   input [width:0]   result;  // The instruction result.
   input 	     add;     // This is an ADD instruction.
   input 	     sub;     // This is an SUB instruction.
   input 	     cmp;     // This is an CMP instruction.
   output 	     c;       // The Carry condition bit.
   output 	     z;       // The Zero condition bit.
   output 	     n;       // The Neagative condition bit.
   output 	     v;       // The oVerflow condition bit.
   
   wire 	     c,z,n,v;
   wire 	     subt;
   
   or #(3) subt_or(subt, sub, cmp);
   assign c =  result[width];
   assign #6 z = ~(|result[width-1:0]);
   assign #12 v =  (result[width-1] & ~op1[width-1] & ~(subt^op2[width-1])) | (~result[width-1] & op1[width-1] & (subt^op2[width-1]));
   assign n =   result[width-1];   
endmodule // setcc

 