module stage5(IR5, Z5, R3, a3, reg_write, hlt5_found, clk, clr, RW5, HALT5);	
   parameter gate_delay = 3;   
   input [31:0] IR5;         // The Instruction Register from pipeline stage 4.
   input [31:0] Z5;          // The ALU result from pipeline stage 4.
   input 	clk;         // The clock.
   input 	clr;         // The clear signal to reset all D-type flip-flops.
   input 	RW5;         // BWAT: The decoded Register Write bit from pipeline stage 4.
   input 	HALT5;       // BWAT: The decoded halt bit from pipeline stage 4.
   output [31:0] R3;         // The contents to be written if reg_write = 1'b1.
   output [4:0]  a3;         // The register to be written if reg_write = 1'b1.
   output 	 reg_write;  // The register file should write R3 to register a3.
   output 	 hlt5_found; // We have executed a halt instruction. This should maybe be in stage 3.

   // defining internal wires
   wire 	 reg_write;
   wire 	 jmpl;
   wire [4:0] 	 a3;
   wire [31:0] 	 R3;
   wire 	 clk,clr;
   wire 	 hlt5_found;
   
   // Module Instantiations
   // has a delay of 6 time units
   // BWAT:   dcd5_32 opdecode5(IR5[31:27], nop5, add5, sub5, or5, and5, not5, xor5, cmp5, br5, jmp5, ld5, ldi5, ldx5, st5, stx5, hlt5);
   // BWAT:  d_reg #(1,8) hlt5_bit(clk, hlt5_found, hlt5, clr); 
   assign hlt5_found = HALT5; // BWAT:
   
   // internal combitional logic to generate reg_write signal
   
   // BWAT: and #(gate_delay) gen_jmpl(jmpl, jmp5, IR5[16]);
   // BWAT: or #(gate_delay) gen_write_or(reg_write, add5, sub5, and5, or5, not5, xor5, jmpl, ld5, ldi5, ldx5);
   assign reg_write = RW5;     // BWAT:
   
   assign a3 = IR5[26:22];
   assign R3 = Z5;   
endmodule // stage5
